/////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 2004 Mothers Ruin Software. All rights reserved.
//
//  MODULE:  Controller.h
//
//  PROJECT: SSHChain
//
//  CREATED: by randy on Sat Jan 10 2004
//
//  $Id: Controller.h,v 1.5 2007/10/02 04:50:18 randy Exp $
//
//  SSHChain is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//  
//  SSHChain is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with SSHChain; if not, write to the Free Software Foundation,
//  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
/////////////////////////////////////////////////////////////////////

#import <Cocoa/Cocoa.h>
@class SSHAgent;
@class EnvFile;

/////////////////////////////////////////////////////////////////////
// class Controller
/////////////////////////////////////////////////////////////////////

/*!
 * @class Controller
 *
 * The Controller class is the top-level controller for the
 * SSHChain application. It is instantiated in main() before
 * entering NSApplicationMain(), and registers itself for
 * NSApplication notifications to detect launch and termination.
 *
 * It interacts with the SSHChain, KeychainHandler and EnvFile
 * to make everything happen.
 */
@interface Controller : NSObject
{
   SSHAgent* m_agent;
   EnvFile*  m_envFile;
   BOOL      m_socketPathChanged;
}

/*!
 * @method init
 *
 * Standard init to be called on construction. Initiates SSHChain
 * tasks by installing NSApplication notification handlers, 
 * including DidFinishLaunching, so it should be created before that.
 *
 * @result
 *    initialized Controller object
 */
- (id) init;

@end
